﻿Global Carry.a

Global DecodeYENOString_LEVEL.a
Global DecodeYENOString_LEVEL1_data.a
Global DecodeYENOString_LEVEL2_data.a
Global DecodeYENOString_LEVEL3_data.a

Global Dim TABLEAU_Normal.a($40)
Global Dim TABLEAU_Uppercase.a($40)
Global TABLEAU_UppercaseBIT.a

Procedure RR(Valeur.a)
  ; Rotate Right
  ; Carry va dans B7
  ; B0 va dans carry.
  ; Rotate sur _9 bits_
  Shared Carry
  
  _TempValeur = Valeur
  _TempValeur = _TempValeur >> 1 ;On décale tout ça vers la droite
  _TempValeur = _TempValeur + (128 * Carry) ; Décale CARRY vers b7
  Carry=Bool(Valeur & 1)                    ; Deréfinis CARRY avec la valeur sortante (b0)
  ProcedureReturn _TempValeur
EndProcedure

Procedure RL(Valeur.a)
  ; Rotate Left
  ; Carry va dans B0
  ; B7 va dans carry.
  ; Rotate sur _9 bits_
  
  Shared carry
  _TempValeur = Valeur
  _TempValeur = _TempValeur << 1 ; On décalte tout ça sur la gauche
  _TempValeur = _TempValeur + Carry ; Décale CARRY vers b0
  Carry=Bool(Valeur & 128) ; Redéfinis CARRY avec la valeur sortante (b7)
  ProcedureReturn _TempValeur
EndProcedure

Octet.a=0


Procedure TranslateToCHAR(Char.a)
  If TABLEAU_UppercaseBIT=0
    Donnee=TABLEAU_Normal(Char)
    If Donnee=$30
      TABLEAU_UppercaseBIT=1
      ProcedureReturn 0 ; On attends le prochain octet pour ça...
    EndIf
  Else
    Donnee=TABLEAU_Uppercase(Char)
    TABLEAU_UppercaseBIT=0
  EndIf
  ProcedureReturn Donnee
EndProcedure

Procedure DecodeYENOString(Char.a)
  ; Cet procédure recompose les octets (6 bits) des //Strings// du Compusavant en 8 bits.
  ; Pour STAGE 4, on ne _DOIT PAS_ lire de données du fichier, il est automatiquement recomposée des autres octets...!
  
  Protected _TempOctet.a
  Protected _TempB.a
  Protected _TempD72A.a
  
  Select DecodeYENOString_LEVEL
    Case 1
      ; On est dans le niveau 1
      DecodeYENOString_LEVEL1_data=Char
      DecodeYENOString_LEVEL=2
      _TempOctet=(Char & $FC)
      _TempOctet=_TempOctet >> 2 ; RRx2
      ProcedureReturn _TempOctet  
    Case 2
      DecodeYENOString_LEVEL2_data=Char
      DecodeYENOString_LEVEL=3
      ; Substage "B"
      _TempB=(DecodeYENOString_LEVEL1_data & $03)
      _TempB=_TempB << 4 ; RLx4
      ;MainStage
      _TempOctet=(Char & $F0)
      _TempOctet=_TempOctet >> 4 ; RRx4
      _TempOctet=_TempOctet+_TempB ; Recomposition de l'octet STAGE 2
      ProcedureReturn _TempOctet
    Case 3
      DecodeYENOString_LEVEL3_data=Char
      DecodeYENOString_LEVEL=4
      ; Substage "D72A"
      _TempD72A=(DecodeYENOString_LEVEL2_data & $0F)
      _TempD72A=_TempD72A << 2 ; RLx2
      ;MainStage
      _TempOctet=(Char & $C0) 
      _TempOctet=_TempOctet >> 6 ;RRx6
      _TempOctet=_TempOctet+_TempD72A ; Remposition de l'octet 
      ProcedureReturn _TempOctet
    Case 4 ; FIXME: /!\ NE PAS LIRE D'OCTETS ! /!\
      DecodeYENOString_LEVEL4_data=Char
      DecodeYENOString_LEVEL=1
      If Char<>0:MessageRequester("ERROR", "DecodeChar() DOES NOT RECIEVE CHAR FOR THIS !", #MB_ICONERROR):EndIf
      _TempD72A=(DecodeYENOString_LEVEL3_data & $3F)
      
      DecodeYENOString_LEVEL1_data=0
      DecodeYENOString_LEVEL2_data=0
      DecodeYENOString_LEVEL3_data=0            
      
      ProcedureReturn _TempD72A
  EndSelect
EndProcedure

Restore TABLEAU_Normal
For x=0 To $3F
  Read.a TABLEAU_Normal(x)
Next x
Restore TABLEAU_Uppercase
For x=0 To $3F
  Read.a TABLEAU_Uppercase(x)
Next x

CreateFile(2, "C:\DUMP\DictDump.txt")
If ReadFile(1, "C:\DUMP\BidouilleROM\DictWhat.bin", #PB_File_SharedRead)
  DecodeYENOString_LEVEL=1 ; Init decoder position...
  StringNumber=1
  
  While(Not Eof(1))
    
    If DecodeYENOString_LEVEL<>4
      Octet=ReadAsciiCharacter(1)
    Else
      Octet=0
    EndIf
    
    OctetDecode=DecodeYENOString(Octet) ; Décode la donnée
    
    If OctetDecode = 0 ; TOUJOURS FAIRE CETTE VERIFICATION /!\
                       ;Debug "FIN STRING"
      If Len(STRINGDecode$)>0
        WriteStringN(2, STRINGDecode$+" Count:$"+RSet(Hex(StringNumber), 4, "0")+" Loc:"+Str(Loc(1)))
        StringNumber+1
      EndIf
      STRINGDecode$=""
      DecodeYENOString_LEVEL=1
      DecodeYENOString_LEVEL1_data=0
      DecodeYENOString_LEVEL2_data=0
      DecodeYENOString_LEVEL3_data=0
    Else
      ;Debug Chr(TranslateToCHAR(OctetDecode))
      STRINGDecode$=STRINGDecode$+Chr(TranslateToCHAR(OctetDecode))
    EndIf
  Wend
EndIf


End
;Inclusion des tableaux de correspondances YENOChar<=>Ascii
;Tableau "NORMAL" ($5395)
DataSection
  TABLEAU_normal:
  Data.a $FF, $FF, $FF, $FF, $07, $08, $09, $0A
  Data.a $30, $61, $62, $63, $64, $65, $66, $67
  Data.a $68, $69, $6A, $6B, $6C, $6D, $6E, $6F
  Data.a $70, $71, $72, $73, $74, $75, $76, $77
  Data.a $78, $79, $7A, $81, $82, $83, $84, $85
  Data.a $87, $88, $89, $8A, $8B, $8C, $8D, $8E
  Data.a $93, $94, $95, $96, $97, $99, $9A, $A4
  Data.a $E1, $2A, $20, $22, $27, $2C, $2D, $2E
  ; Tableau "UPPERCASE" (++$40)
  TABLEAU_uppercase:
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $30, $31, $32, $33, $34, $35, $36, $37
  Data.a $38, $39, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $F8, $21, $2B, $2F, $3B, $3D, $A1
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
EndDataSection
; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 118
; Folding = w
; EnableXP