﻿Global Carry.a

Global PosLettre.a

Global DecodeYENOString_LEVEL.a
Global DecodeYENOString_LEVEL1_data.a
Global DecodeYENOString_LEVEL2_data.a
Global DecodeYENOString_LEVEL3_data.a

Global Dim TABLEAU_Normal.a($40)
Global Dim TABLEAU_Uppercase.a($40)
Global TABLEAU_UppercaseBIT.a

Procedure RR(Valeur.a)
  ; Rotate Right
  ; Carry va dans B7
  ; B0 va dans carry.
  ; Rotate sur _9 bits_
  Shared Carry
  
  _TempValeur = Valeur
  _TempValeur = _TempValeur >> 1 ;On décale tout ça vers la droite
  _TempValeur = _TempValeur + (128 * Carry) ; Décale CARRY vers b7
  Carry=Bool(Valeur & 1)                    ; Deréfinis CARRY avec la valeur sortante (b0)
  ProcedureReturn _TempValeur
EndProcedure

Procedure RL(Valeur.a)
  ; Rotate Left
  ; Carry va dans B0
  ; B7 va dans carry.
  ; Rotate sur _9 bits_
  
  Shared carry
  _TempValeur = Valeur
  _TempValeur = _TempValeur << 1 ; On décalte tout ça sur la gauche
  _TempValeur = _TempValeur + Carry ; Décale CARRY vers b0
  Carry=Bool(Valeur & 128) ; Redéfinis CARRY avec la valeur sortante (b7)
  ProcedureReturn _TempValeur
EndProcedure

Octet.a=0


Procedure TranslateToCHAR(Char.a)
  If TABLEAU_UppercaseBIT=0
    Donnee=TABLEAU_Normal(Char)
    If Donnee=$30
      TABLEAU_UppercaseBIT=1
      ProcedureReturn 0 ; On attends le prochain octet pour ça...
    EndIf
  Else
    Donnee=TABLEAU_Uppercase(Char)
    TABLEAU_UppercaseBIT=0
  EndIf
  ProcedureReturn Donnee
EndProcedure

Procedure TranslateToYENO(Char.a)
  ;Char=Asc(LCase(Str(Char)))
  For x=0 To $3F
    If Char=TABLEAU_Normal(x) And Resultat=0
      Resultat=x
    EndIf
  Next
  
  If Resultat=0
    ;Debug "Unsupported CHAR:"+Char
    ;Zero=0
    ;Debug 4/Zero
  EndIf
  ProcedureReturn Resultat
EndProcedure
  
  

Procedure DecodeYENOString(Char.a)
  ; Cet procédure recompose les octets (6 bits) des //Strings// du Compusavant en 8 bits.
  ; Pour STAGE 4, on ne _DOIT PAS_ lire de données du fichier, il est automatiquement recomposée des autres octets...!
  
  Protected _TempOctet.a
  Protected _TempB.a
  Protected _TempD72A.a
  
  Select DecodeYENOString_LEVEL
    Case 1
      ; On est dans le niveau 1
      DecodeYENOString_LEVEL1_data=Char
      DecodeYENOString_LEVEL=2
      _TempOctet=(Char & $FC)
      _TempOctet=_TempOctet >> 2 ; RRx2
      ProcedureReturn _TempOctet  
    Case 2
      DecodeYENOString_LEVEL2_data=Char
      DecodeYENOString_LEVEL=3
      ; Substage "B"
      _TempB=(DecodeYENOString_LEVEL1_data & $03)
      _TempB=_TempB << 4 ; RLx4
      ;MainStage
      _TempOctet=(Char & $F0)
      _TempOctet=_TempOctet >> 4 ; RRx4
      _TempOctet=_TempOctet+_TempB ; Recomposition de l'octet STAGE 2
      ProcedureReturn _TempOctet
    Case 3
      DecodeYENOString_LEVEL3_data=Char
      DecodeYENOString_LEVEL=4
      ; Substage "D72A"
      _TempD72A=(DecodeYENOString_LEVEL2_data & $0F)
      _TempD72A=_TempD72A << 2 ; RLx2
      ;MainStage
      _TempOctet=(Char & $C0) 
      _TempOctet=_TempOctet >> 6 ;RRx6
      _TempOctet=_TempOctet+_TempD72A ; Remposition de l'octet 
      ProcedureReturn _TempOctet
    Case 4 ; FIXME: /!\ NE PAS LIRE D'OCTETS ! /!\
      DecodeYENOString_LEVEL4_data=Char
      DecodeYENOString_LEVEL=1
      If Char<>0:MessageRequester("ERROR", "DecodeChar() DOES NOT RECIEVE CHAR FOR THIS !", #MB_ICONERROR):EndIf
      _TempD72A=(DecodeYENOString_LEVEL3_data & $3F)
      
      DecodeYENOString_LEVEL1_data=0
      DecodeYENOString_LEVEL2_data=0
      DecodeYENOString_LEVEL3_data=0            
      
      ProcedureReturn _TempD72A
  EndSelect
EndProcedure

Global Octet1.a, Octet2.a, Octet3.a, Octet4.a
Global Sortie1.a, Sortie2.a, Sortie3.a

Procedure CompressToDico()
  Sortie1=0
  Sortie2=0
  Sortie3=0
  
  Sortie1+(Bool(Octet1 & $20) * $80) ; Octet 1 => Sortie 1
  Sortie1+(Bool(Octet1 & $10) * $40) ; Octet 1 => Sortie 1
  Sortie1+(Bool(Octet1 & $08) * $20) ; Octet 1 => Sortie 1
  Sortie1+(Bool(Octet1 & $04) * $10) ; Octet 1 => Sortie 1
  Sortie1+(Bool(Octet1 & $02) * $08) ; Octet 1 => Sortie 1
  Sortie1+(Bool(Octet1 & $01) * $04) ; Octet 1 => Sortie 1
  Sortie1+(Bool(Octet2 & $20) * $02) ; Octet 2 => Sortie 1
  Sortie1+(Bool(Octet2 & $10) * $01) ; Octet 2 => Sortie 1
  
  Sortie2+(Bool(Octet2 & $08) * $80)
  Sortie2+(Bool(Octet2 & $04) * $40)
  Sortie2+(Bool(Octet2 & $02) * $20)
  Sortie2+(Bool(Octet2 & $01) * $10)
  Sortie2+(Bool(Octet3 & $20) * $08)
  Sortie2+(Bool(Octet3 & $10) * $04)
  Sortie2+(Bool(Octet3 & $08) * $02)
  Sortie2+(Bool(Octet3 & $04) * $01)
  
  Sortie3+(Bool(Octet3 & $02) * $80)
  Sortie3+(Bool(Octet3 & $01) * $40)
  Sortie3+(Bool(Octet4 & $20) * $20)
  Sortie3+(Bool(Octet4 & $10) * $10)
  Sortie3+(Bool(Octet4 & $08) * $08)
  Sortie3+(Bool(Octet4 & $04) * $04)
  Sortie3+(Bool(Octet4 & $02) * $02)
  Sortie3+(Bool(Octet4 & $01) * $01)
EndProcedure

Procedure RenvoieLettre(Chaine.s) 
  If PosLettre=Len(Chaine)
    ProcedureReturn 0
    End
  EndIf
  PosLettre+1
  ProcedureReturn Asc(Mid(Chaine, PosLettre, 1))
EndProcedure


Restore TABLEAU_Normal
For x=0 To $3F
  Read.a TABLEAU_Normal(x)
Next x
Restore TABLEAU_Uppercase
For x=0 To $3F
  Read.a TABLEAU_Uppercase(x)
Next x



;Debug TranslateToYENO('a')
; Len MAX à générer : $4594C

LaChaine$="zzzz"
PosLettre=0 ; Position du curseur
JaiFini=0 ; Passage à 1 si c'est FINI!

While(JaiFini=0)
  
  
  If JaiFini=0
    ;Pass 1 ; on complète Octet1,2,3,4 avec les YENOChar de LaChaine$
    Octet1=TranslateToYENO(RenvoieLettre(LaChaine$)) : If Octet1=0 :  JaiFini=1 : EndIf
    Octet2=TranslateToYENO(RenvoieLettre(LaChaine$)) : If Octet1=0 :  JaiFini=1 : EndIf
    Octet3=TranslateToYENO(RenvoieLettre(LaChaine$)) : If Octet1=0 :  JaiFini=1 : EndIf
    Octet4=TranslateToYENO(RenvoieLettre(LaChaine$)) : If Octet1=0 :  JaiFini=1 : EndIf
    
    CompressToDico() ; Passage de 8 à 6 bits...
    
    If Sortie1<>0 : Debug RSet(Hex(Sortie1, #PB_Byte), 2, "0") : EndIf
    If Sortie2<>0 : Debug RSet(Hex(Sortie2, #PB_Byte), 2, "0") : EndIf
    If Sortie3<>0 : Debug RSet(Hex(Sortie3, #PB_Byte), 2, "0") : EndIf
  EndIf
Wend












End
;Inclusion des tableaux de correspondances YENOChar<=>Ascii
;Tableau "NORMAL" ($5395)
DataSection
  TABLEAU_normal:
  Data.a $FF, $FF, $FF, $FF, $07, $08, $09, $0A
  Data.a $30, $61, $62, $63, $64, $65, $66, $67
  Data.a $68, $69, $6A, $6B, $6C, $6D, $6E, $6F
  Data.a $70, $71, $72, $73, $74, $75, $76, $77
  Data.a $78, $79, $7A, $81, $82, $83, $84, $85
  Data.a $87, $88, $89, $8A, $8B, $8C, $8D, $8E
  Data.a $93, $94, $95, $96, $97, $99, $9A, $A4
  Data.a $E1, $2A, $20, $22, $27, $2C, $2D, $2E
  ; Tableau "UPPERCASE" (++$40)
  TABLEAU_uppercase:
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $30, $31, $32, $33, $34, $35, $36, $37
  Data.a $38, $39, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $F8, $21, $2B, $2F, $3B, $3D, $A1
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
  Data.a $FF, $FF, $FF, $FF, $FF, $FF, $FF, $FF
EndDataSection
; IDE Options = PureBasic 5.50 (Windows - x86)
; CursorPosition = 186
; FirstLine = 70
; Folding = M-
; EnableXP